SystemOrganization addCategory: #'GBT-DSL_BuddyWallet'!

Object subclass: #BuddyWallet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_BuddyWallet'!

!BuddyWallet class methodsFor: 'example' stamp: 'hk 1/9/2018 13:29'!
exampleRun
	GbtServer initialize: #BW; clearStore: #BW. 
	(self new 
		ensureCompilation;
		storeAccounts ;
		installUsers;
		login)
		open
! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 8/16/2017 17:21'!
account
	"self new account"
	^GbtSmartNode copy: 'Account'! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:04'!
account01
	"self new account01 edit"
	^self account
		bizId: self nextBizID;
		nick: #firstAccount;
		IBAN: 'DE51 1234 5678 9876 5432' ;	
		amount: 1000;
		firstName: #Lisa ;
		lastName: #Schmitz;
		eMail: 'Lisa.Schmitz@web.de';
		yourself.

! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:05'!
account02
	"self new account02 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 9876 1234' ;	
		amount: 500;
		firstName: #Tom ;
		lastName: #Taylor;
		eMail: 'Tom.Taylor@gmx.net';
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:05'!
account03
	"self new account03 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 0054 1234' ;	
		amount: 1000;
		firstName: #Helmut ;
		lastName: #Lange;
		eMail: 'Helmut@Lange.de';
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:04'!
account04
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 0045 9876';
		nick: #otherAccount;
		amount: -500;
		firstName: #Lisa;
		lastName: #Schmitz;
		eMail: 'Lisa.Schmitz@web.de';
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:05'!
account05
	"self new account05 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 9999 7777' ;	
		amount: 800;
		firstName: #Helmut ;
		lastName: #Schmidt;
		eMail: 'Helmut@Schmidt.de';
		yourself! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 1/27/2018 16:37'!
buddyWallet  
	^GbtSmartContext definedAs: 'BuddyWallet' ! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 1/28/2018 14:21'!
contexts
	^ '	plain BuddyWalletLogin {
		subcontexts 	: 	BuddyWallet 
		uiSpec 		: 	GbtLoginUI 
		icon 			: 	walletBig
		displayAs 	: 	BuddyWallet Login
		legalText 	: 	GloConn International © 2018
		}
	plain BuddyWallet {
		subcontexts 	: 	MyAccounts Buddies Transfers 
		uiSpec 		: 	GbtMainUI 
		icon 			: 	walletBig
		windowSize 	: 	800 @ 600
		legalText 	: 	GloConn International © 2018
		}
	plain MyAccountContext { 
	 	displayAs 	: 	My Account
		uiSpec 		: 	GbtItemUI
		icon 			: 	contacts
		}
	plain TransferContext {  
	 	displayAs 	: 	Transfer Order
		uiSpec 		: 	GbtItemUI
		icon 			: 	wallet
		pool 			: 	TransferRules SourceProjector SinkProjector Transfer
		menu 			: 	doit
		onCreate 		:  userName
		onExpand 		: 	source chooseS
		onExpand 		: 	target chooseT
		behaviors 	:  doit userName chooseS chooseT
		}
	behavior userName { 
		userName 			:  TransferOrder:senderName := TransferContext:user
		}
	behavior chooseS { 
		sourceAcc 		:  askContext(MyAccounts)
		chooseS 			:  sourceAcc:nick
		}
	behavior chooseT { 
		sourceAcc 		:  askContext(Buddies)
		chooseT 			:  sourceAcc:eMail
		}
	behavior doit { 
		source 			:  contextThing:source
		senders 			: 	 select(contextList(MyAccounts) source)
		sourceAcc 		:  askUser(''auf welches Konto?'' senders)
		sourceVars		:  transform( SourceProjector sourceAcc) 									
		sink 				:  contextThing:target
		sinkAcc 			:  askUser( Empfänger select(contextList(Buddies) sink))
		sinkVars 			:  transform(SinkProjector sinkAcc )
		transfer 			: 	transform (Transfer TransferOrder TransferRules sourceVars sinkVars)
		transferOK 		:  checkConstraints (transfer)
		sourceA 			:  sourceAcc:amount := transferOK:newSourceAmount
		sinkA				:  sinkAcc:amount := transferOK:newSinkAmount
		sourceAccount 	: 	sourceA:saveContext := Buddies							% saveContext needed
		sinkAccount 		: 	sinkA:saveContext := MyAccounts						% due to awkward construction
		doit				:  commit(sourceAccount sinkAccount transferOK)	
		}
	
	primeList MyAccounts of Account {  
	 	displayAs 	: 	Accounts
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	contacts
		loadPolicy 	: 	autoload 
		listColumns 	: 	(nick nickName) amount IBAN 
		listPrefix 	: 	Acc 
		subcontext 	: 	MyAccountContext 
		}
	primeList Transfers of TransferOrder {  
	 	displayAs 	: 	Transfers
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	wallet
		loadPolicy 	: 	autoload 
		listColumns 	: 	(senderName von) (transferAmount amount) currency (source von) (target an) 
		listPrefix 	: 	MTF 
		subcontext 	: 	TransferContext 
		}
	primeList Buddies of Account {  
	 	displayAs 	: 	Buddies
		uiSpec 		: 	GbtListUI
		icon 			: 	crm
		loadPolicy 	: 	autoload 
		listColumns 	: 	firstName eMail 
		}
	'! !

!BuddyWallet methodsFor: 'compile' stamp: 'hk 1/27/2018 16:50'!
ensureCompilation
	"sort of incremental ..."
	| compiler |
	compiler := GbtCompiler new.
	{self things . self projectors . self contexts } do: [:sources | 
		compiler parse: sources onError: [ :msg :pos | self error: msg, ' at: ', pos printString ]]! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 8/16/2017 17:15'!
installUsers
	#(Tom Lisa) do: [:u| GbtServer default addUser: u withRole: 
			(GbtRole forExecute 
				addFilter: '#firstName = ''',u asString, '''' for: #MyAccounts;
				addFilter: '#senderName = ''',u asString, '''' for: #Transfers) ].
	#(Tony Robert) do: [:u| GbtServer default addUser: u withRole: (GbtRole forWrite )].
	#(Bob) do: [:u| GbtServer default addUser: u withRole: (GbtRole forRead )]
! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 1/27/2018 16:37'!
login
	^GbtSmartContext definedAs:  'BuddyWalletLogin'! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 8/16/2017 17:15'!
nextBizID
	^GbtServer default nextIdOfContextNoPolicy: #MyAccounts! !

!BuddyWallet methodsFor: 'functions' stamp: 'hk 1/27/2018 17:37'!
projectors
	^'
	projector SourceProjector  {
		tag oldSourceAmount : amount 
		dispo 
		transferLimit  
		}
	
	projector SinkProjector {
		tag oldSinkAmount : amount 
		}
		
	projector Transfer  { 
		oldSourceAmount  oldSinkAmount  dispo  transferLimit  transferAmount
		newSourceAmount newSinkAmount limitConstraint dispoConstraint 
		date
		}
	'
! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 12/31/2017 19:14'!
storeAccounts
	"creates the noPolicy for the test data"
	self account01 storeSubtree.
	self account02 storeSubtree.
	self account03 storeSubtree. 
	self account04 storeSubtree.
	self account05 storeSubtree! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 12/1/2017 12:52'!
things
^'	thing Contact { 
		*val firstName 		:  
		*val lastName  		:  
		*val eMail     		:   					
		val phone     		:   
		}
	thing Account 
		summary 				:  #firstName #nick
		{ 
		*val nick 			:  soleAccount 
		*val IBAN 			:   
		*no amount 			:  0 
		*val currency 		:  EUR
		*no dispo 			:  0 
		*no transferLimit 	:  1000 
		*node person 		:  Contact
		}
	thing TransferOrder
		summary 				:  transfer order template
		{ 
		*val senderName  	:  
		*no transferAmount :  0 
		*val currency 		:  EUR 
		val source 			: 
		val target 			: 
		*date date 			:  date(today)
		}				
	thing TransferRules {  
		*no newSourceAmount 				:  #oldSourceAmount - #transferAmount
		*no newSinkAmount 					:  #oldSinkAmount + #transferAmount  
		*constraint limitConstraint 	:  #transferAmount < #transferLimit {ifViolated: limit exceeded }  %comment
		*constraint dispoConstraint 	:  #oldSourceAmount - #transferAmount + #dispo >= 0 {ifViolated: no balace cover }
		}
'
! !
